#
# refile.rb
#
#   Copyright (c) 1999,2000 Minero Aoki <aamine@dp.u-netsurf.ne.jp>
#
#   This program is free software.
#   You can distribute/modify this program under the terms of
#   the GNU Lesser General Public License version 2 or later.
#

require 'est/strategy'


module EST

  class Refiler < Strategy

    RC_DEFAULT = {}

    def refile( mbname = nil )
      mset = CORE.mailbox
      if mbname then
        from = mset[mbname]
      else
        from = mset.inbox
      end
      return if from.empty?
      return if @rc['rule'].empty?

      rl = []
      @rc['rule'].each do |ent|
        unless mb = mset[ ent[2] ] then
          CORE.warn "target mbox '#{to}' not exist: skip"
        end
        rl.push [ent[0], ent[1], mb]
      end
        
      to = nil
      from.move_if do |port|
        to = nil
        mail = Mail.new( port )

        rl.each do |nm, re, to|
          unless hf = mail[nm] then
            next
          end
          if re === hf.body then
            to = mb
            break
          end
        end
        to
      end
    end

  end

end
